// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals(0, v8ToLength(NaN));

assertEquals(0, v8ToLength(-Infinity));

assertEquals(0, v8ToLength(0));

assertEquals(0, v8ToLength(.5));

assertEquals(42, v8ToLength(42.99999));

assertEquals(9007199254740991, v8ToLength(9007199254740991));

assertEquals(9007199254740991, v8ToLength(Infinity));

assertEquals(0, v8ToLength(null));

assertEquals(1, v8ToLength(true));

assertEquals(0, v8ToLength(false));

assertEquals(0, v8ToLength(undefined));

assertEquals(0, v8ToLength("-1"));
assertEquals(123, v8ToLength("123"));
assertEquals(0, v8ToLength("random text"));

assertThrows(function() { v8ToLength(Symbol.toPrimitive) }, TypeError);

var a = { toString: function() { return 54321 }};
assertEquals(54321, v8ToLength(a));

var b = { valueOf: function() { return 42 }};
assertEquals(42, v8ToLength(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals(123, v8ToLength(c));

var d = {
  [Symbol.toPrimitive]: function(hint) {
    assertEquals("number", hint);
    return 987654321;
  }
};
assertEquals(987654321, v8ToLength(d));

var e = new Date(0);
assertEquals(0, v8ToLength(e));
